Ruby: pm_call_and_write_node Struct Reference

Ruby 3.4.4p34 (2025-05-14 revision a38531fd3f617bf734ef7d6c595325f69985ea1d)

Data Fields
pm_call_and_write_node Struct Reference

CallAndWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| CallAndWriteNode#receiver.
pm_location_t | call_operator_loc
| CallAndWriteNode#call_operator_loc.
pm_location_t | message_loc
| CallAndWriteNode#message_loc.
pm_constant_id_t | read_name
| CallAndWriteNode#read_name.
pm_constant_id_t | write_name
| CallAndWriteNode#write_name.
pm_location_t | operator_loc
| CallAndWriteNode#operator_loc.
struct pm_node * | value
| CallAndWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

CallAndWriteNode.

Represents the use of the `&&=` operator on a call.

    foo.bar &&= value
    ^^^^^^^^^^^^^^^^^

Type: PM_CALL_AND_WRITE_NODE

Flags (pm_call_node_flags):

- PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- PM_CALL_NODE_FLAGS_VARIABLE_CALL
- PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 2010 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_call_and_write_node::base

The embedded base node.

Definition at line 2012 of file ast.h.

Referenced by pm_dump_json().

## ◆ call_operator_loc

pm_location_t pm_call_and_write_node::call_operator_loc

CallAndWriteNode#call_operator_loc.

Represents the location of the call operator.

    foo.bar &&= value
       ^

Definition at line 2033 of file ast.h.

Referenced by pm_dump_json().

## ◆ message_loc

pm_location_t pm_call_and_write_node::message_loc

CallAndWriteNode#message_loc.

Represents the location of the message.

    foo.bar &&= value
        ^^^

Definition at line 2043 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_call_and_write_node::operator_loc

CallAndWriteNode#operator_loc.

Represents the location of the operator.

    foo.bar &&= value
            ^^^

Definition at line 2073 of file ast.h.

Referenced by pm_dump_json().

## ◆ read_name

pm_constant_id_t pm_call_and_write_node::read_name

CallAndWriteNode#read_name.

Represents the name of the method being called.

    foo.bar &&= value # read_name `:bar`
        ^^^

Definition at line 2053 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_call_and_write_node::receiver

CallAndWriteNode#receiver.

The object that the method is being called on. This can be either `nil` or any non-void expression.

    foo.bar &&= value
    ^^^

Definition at line 2023 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_call_and_write_node::value

CallAndWriteNode#value.

Represents the value being assigned.

    foo.bar &&= value
                ^^^^^

Definition at line 2083 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ write_name

pm_constant_id_t pm_call_and_write_node::write_name

CallAndWriteNode#write_name.

Represents the name of the method being written to.

    foo.bar &&= value # write_name `:bar=`
        ^^^

Definition at line 2063 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h